#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

int
main(int argc, char **argv)
{
    void *handle;
    char * (*hello)(char*);
    void * (*helloworld)();
    char *error;

    handle = dlopen("libhelloworld.so", RTLD_LAZY);
    if (!handle) {
        fprintf(stderr, "%s\n", dlerror());
        exit(EXIT_FAILURE);
    }

    dlerror();    /* Clear any existing error */

    *(void **) (&hello) = dlsym(handle, "hello");
    *(void **) (&helloworld) = dlsym(handle, "helloworld");

    if ((error = dlerror()) != NULL)  {
        fprintf(stderr, "%s\n", error);
        exit(EXIT_FAILURE);
    }

    printf("%s\n", (*hello)("carr3r"));
    helloworld();

    dlclose(handle);
    exit(EXIT_SUCCESS);
}
